import { LRLanguage, LanguageSupport } from "@codemirror/language";
import { Extension, EditorState, Text } from "@codemirror/state";
import { PluginValue, ViewPlugin } from "@codemirror/view";
type snippetsArguments = {
    snippets: boolean;
    variables: boolean;
    registers: boolean;
    logic: boolean;
};
type snippetsOptions = Partial<snippetsArguments>;
type setChar = (line: number, char: string | null) => Record<number, string | null>;
type gutterArguments = {
    chars: Record<number, string | null>;
};
type gutterOptions = Partial<gutterArguments>;
type hoverArguments = {
    startLine: number;
    callback?: (word: string, text: string | null, line: number, value?: string) => string | null;
};
type hoverOptions = Partial<hoverArguments>;
declare const icLanguage: LRLanguage;
declare function ic10(): LanguageSupport;
declare const ic10Snippets: (snippetsArguments?: snippetsOptions) => import("@codemirror/state").Extension;
declare const ic10HoverTooltip: (options?: hoverOptions) => Extension;
declare const createLineGutter: (options?: gutterOptions) => [
    Extension,
    setChar
];
declare const customLineNumbers: (fn: (n: number, state: EditorState) => string) => import("@codemirror/state").Extension;
declare const zeroLineNumbers: import("@codemirror/state").Extension;
declare function getLines(doc: Text): string[];
declare const createRuler: (pos: number, className?: string) => readonly [
    ViewPlugin<PluginValue>,
    HTMLDivElement
];
declare class lineClassController {
    readonly className: string;
    private readonly addLineHighlight;
    private readonly lineHighlightField;
    private readonly lineHighlightMark;
    private line;
    private editorView?;
    readonly extension: Extension[];
    private _ready;
    get ready(): boolean;
    constructor(className: string);
    highlightLine(line: number): boolean;
}
export { icLanguage, ic10, ic10Snippets, ic10HoverTooltip, createLineGutter, zeroLineNumbers, customLineNumbers, getLines, createRuler, lineClassController };
export type { snippetsOptions, gutterOptions, hoverOptions };
